#!/bin/bash

sed ':start; /\\$/ { N; s/\\\n/\\\x00/; b start }' .zsh_history  # join multiline commands
| nl -nrz                  # add line numbers so we can restore the original order
| tac | sort -t';' -u -k2  # sort and remove duplicate commands, keeping the last occurrence
| sort                     # sort on line numbers
| cut -d$'\t' -f2-         # remove the line numbers
| tr '\000' '\n'           # restore multiline commands
> .zsh_history_deduped